<template>
	<v-container>
		<v-snackbar
			v-model="snack"
			:timeout="timeout"
			top
			color="green"
			class="subtitle-1"
		>Archivos subidos correctamente</v-snackbar>
		<v-snackbar v-model="snackEstudio" :timeout="3000" top color="orange" class="subtitle-1">No olvides hacer el estudio socioeconómico.</v-snackbar>
		<p class="text-center display-1">Subida de documentos</p>
		<v-form ref="FormUploadDocumentsRenovation" v-model="isValid">
			<!-- Para talento especial -->
			<v-row v-if="typeRenovationScholarship === 'Talento especial'">
				<v-col cols="12" sm="6" md="4" v-for="item of dataDocumentsTalent" :key="item.title">
					<v-card outlined>
						<v-card color="#c51f2f" height="60">
							<v-card-text>
								<p class="text-center white--text title">{{item.title}}</p>
							</v-card-text>
						</v-card>
						<v-card-text>
							<p class="subtitle-1">Descripción: {{item.desc}}</p>
							<v-file-input
								:prepend-icon="item.icon"
								@change="handler($event,item.model)"
								show-size
								:rules="rulesDocuments"
								label="Selecciona un archivo"
								dense
								rounded
								outlined
								:accept="item.accept"
								required
							/>
						</v-card-text>
					</v-card>
				</v-col>
			</v-row>
			<!-- Para no talento especial -->
			<v-row v-else>
				<v-col cols="12" sm="6" md="4" v-for="item of dataDocuments" :key="item.title">
					<v-card outlined>
						<v-card color="#c51f2f" height="60">
							<v-card-text>
								<p class="text-center white--text title">{{item.title}}</p>
							</v-card-text>
						</v-card>
						<v-card-text>
							<p class="subtitle-1">Descripción: {{item.desc}}</p>
							<v-file-input
								:prepend-icon="item.icon"
								@change="handler($event,item.model)"
								show-size
								:rules="rulesDocuments"
								label="Selecciona un archivo"
								dense
								rounded
								outlined
								:accept="item.accept"
								required
							/>
						</v-card-text>
					</v-card>
				</v-col>
			</v-row>
			<v-row justify="center" justify-sm="space-around">
				<v-col cols="12" sm="3">
					<v-btn color="blue" outlined block :to="{name:'AvailableScholarships'}">Atras</v-btn>
				</v-col>
				<v-col cols="12" sm="3">
					<v-btn
						:disabled="!isValid || uploaded"
						:loading="loading"
						outlined
						block
						color="green"
						@click="sendDocuments"
					>Subir documentos</v-btn>
				</v-col>
			</v-row>
		</v-form>
	</v-container>
</template>

<script>
import axios from "axios";
import { mapState, mapMutations } from "vuex";
import gql from "graphql-tag";
import EventBus from '../../bus';

export default {
	name: "FormUploadDocumentsRenovation",
	data: () => ({
		isValid: true,
		uploaded: false,
		loading: false,
		snack: false,
		snackEstudio: true,
		timeout: 2000,
		typeRenovationScholarship: "",
		documentsTalent: {
			ine: {},
			kardex: {},
			const: {},
			ss: {},
			reco: {}
		},
		documents: {
			ine: {},
			kardex: {},
			const: {},
			ss: {}
		},
		dataDocumentsTalent: [
			{
				title: "INE",
				desc: "Credencial de elector vigente.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "documentsTalent.ine"
			},
			{
				title: "Kardex de calificaciones",
				desc: "Constancia de calificaciones generales.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "documentsTalent.kardex"
			},
			{
				title: "Comprobante de inscripción",
				desc: "Constancia de estudios.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "documentsTalent.const"
			},
			{
				title: "Servicio social",
				desc: "Servicio social del semestre anterior.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "documentsTalent.ss"
			},
			{
				title: "Premio nacional",
				desc: "Reconocimiento nacional vigente.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "documentsTalent.reco"
			}
		],
		dataDocuments: [
			{
				title: "INE",
				desc: "Credencial de elector vigente.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "documents.ine"
			},
			{
				title: "Kardex de calificaciones",
				desc: "Constancia de calificaciones generales.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "documents.kardex"
			},
			{
				title: "Comprobante de inscripción",
				desc: "Constancia de estudios.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "documents.const"
			},
			{
				title: "Servicio social",
				desc: "Servicio social del semestre anterior.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "documents.ss"
			}
		],
		rulesDocuments: [
			value => !!value || "Campo requerido",
			value =>
				!value ||
				value.size < 1000000 ||
				"El archivo no debe pesar mas de 1 mb"
		]
	}),
	computed: {
		...mapState(["userData"])
	},
	methods: {
		...mapMutations(["saveUserData"]),

		nameScholarship() {
			switch (this.$route.params.typeRenovationScholarship) {
				case "talento-especial":
					this.typeRenovationScholarship = "Talento especial";
					break;
				case "excelencia-académica":
					this.typeRenovationScholarship = "Excelencia académica";
					break;
				case "mejora-académica":
					this.typeRenovationScholarship = "Mejora académica";
					break;
				case "labsol":
					this.typeRenovationScholarship = "Labsol";
					break;
			}
		},
		// Evento que guarda el documento subido en cada variable
		handler(e, i) {
			this.saveUserData();
			if (this.typeRenovationScholarship === "Talento especial") {
				switch (i) {
					case "documentsTalent.ine":
						this.documentsTalent.ine = e;
						break;
					case "documentsTalent.kardex":
						this.documentsTalent.kardex = e;
						break;
					case "documentsTalent.const":
						this.documentsTalent.const = e;
						break;
					case "documentsTalent.ss":
						this.documentsTalent.ss = e;
						break;
					case "documentsTalent.reco":
						this.documentsTalent.reco = e;
						break;
				}
			} else if (this.typeRenovationScholarship !== "Talento especial") {
				switch (i) {
					case "documents.ine":
						this.documents.ine = e;
						break;
					case "documents.kardex":
						this.documents.kardex = e;
						break;
					case "documents.const":
						this.documents.const = e;
						break;
					case "documents.ss":
						this.documents.ss = e;
						break;
				}
			}
		},
		// Envia los documentos al servidor
		async sendDocuments() {
			// FormData para poder convertir los documentos obtenidos y enviarlos al server
			try {
				// codigo para beca talento especial
				if (this.typeRenovationScholarship === "Talento especial") {
					let formDataTalent = new FormData();

					const filesToUploadTalent = [
						{ file: this.documentsTalent.ine, name: "ine.pdf" },
						{
							file: this.documentsTalent.kardex,
							name: "kardex.pdf"
						},
						{ file: this.documentsTalent.const, name: "const.pdf" },
						{ file: this.documentsTalent.ss, name: "ss.pdf" },
						{ file: this.documentsTalent.reco, name: "reco.pdf" }
					];

					for (let i of filesToUploadTalent) {
						formDataTalent.append("files", i.file, i.name);
					}
					// peticion que envia los archivos
					await axios.post(
						"/uploadFiles/renovation",
						formDataTalent,
						{
							headers: {
								"Content-Type": "multipart/form-data",
								Authorization: `${sessionStorage.getItem(
									"token"
								)}`
							}
						}
					);
					// mutation que agrega la beca al historial
					await this.$apollo.mutate({
						mutation: gql`
							mutation($scholarship: String!) {
								addScholarship(scholarship: $scholarship)
							}
						`,
						variables: {
							scholarship: this.typeRenovationScholarship
						}
					});
					this.loading = true;
					setTimeout(() => {
						this.snack = true;
						this.loading = false;
						this.uploaded = true;
						setTimeout(() => {
							EventBus.$emit('openFormEconomicStudy');
						},1000);
					}, 3000);
				}
				// codigo para beca que sea diferente a talento especial
				else if (
					this.typeRenovationScholarship !== "Talento especial"
				) {
					let formData = new FormData();

					const filesToUpload = [
						{ file: this.documents.ine, name: "ine.pdf" },
						{ file: this.documents.kardex, name: "kardex.pdf" },
						{ file: this.documents.const, name: "const.pdf" },
						{ file: this.documents.ss, name: "ss.pdf" }
					];

					for (let i of filesToUpload) {
						formData.append("files", i.file, i.name);
					}

					// peticion que envia los archivos
					await axios.post("/uploadFiles/renovation", formData, {
						headers: {
							Authorization: sessionStorage.getItem("token"),
							"Content-Type": "multipart/form-data"
						}
					});
					// mutation que agrega la beca al historial
					await this.$apollo.mutate({
						mutation: gql`
							mutation($curp: String!, $scholarship: String!) {
								addScholarship(
									curp: $curp
									scholarship: $scholarship
								)
							}
						`,
						variables: {
							curp: this.userData.curp,
							scholarship: this.typeRenovationScholarship
						}
					});
					this.loading = true;
					setTimeout(() => {
						this.snack = true;
						this.loading = false;
						this.uploaded = true;
						setTimeout(() => {
							EventBus.$emit('openFormEconomicStudy');
						},1000);
					}, 3000);
				}
			} catch (error) {}
		},
		// obtiene el status del estudio socioeconomico
		async getSocioeconomicStudy(){
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query($curp: String!){
							findStudent(curp: $curp){
								documents{
									socioeconomicStudy{
										status
									}
								}
							}
						}
					`,
					variables:{
						curp: this.userData.curp
					}
				});

				data.findStudent.documents === null ? this.snackEstudio = true : this.snackEstudio = false;
			} catch (error) {}
		}
	},
	created() {
		this.saveUserData();
		this.nameScholarship();
		this.getSocioeconomicStudy();
	}
};
</script>